# Smile Appointment Scheduler

Based in two other components, Smile Date Picker and Smile Time Picker

### Available Props

| Prop                        | Type    | Required/Optional | Default value                                                  | Description                                   |
| --------------------------- | ------- | ----------------- | -------------------------------------------------------------- | --------------------------------------------- |
| `appointments`              | Array   | Required          | -                                                              | Date or time to select.                       |
| `dateConfig and timeConfig` | Object  | Optional          | `{ responsive: true,showArrows: true, showScrollbar: false, }` | Component configurations.                     |
| `autoSelect`                | Boolean | Optional          | `true`                                                         | If true then call `selectInitialDate` method. |
| `v-model`                   | Number  | Optional          | 0                                                              | Selected time index.                          |

## Available events

| Event name | Description                                                                                      |
| ---------- | ------------------------------------------------------------------------------------------------ |
| `select`   | The select event is emitted when the selectedDate or selectedTime computed properties are called |

## Basic Usage

```html
<smile-appointment-scheduler
	v-model="model"
	:appointments="data"
	:dateConfig="config"
	:timeConfig="config"
/>
```

# Smile Time Picker

Select a time for appointment.

### Available Props

| Prop            | Type    | Required/Optional | Default value | Description                                       |
| --------------- | ------- | ----------------- | ------------- | ------------------------------------------------- |
| `times`         | Array   | Required          | -             | Times to select.                                  |
| `v-model`       | Number  | Optional          | 0             | Selected time index.                              |
| `config`        | Object  | Optional          | -             | Component configurations.                         |
| `legacy-design` | Boolean | Optional          | `false`       | Makes the component look like our legacy designs. |

## Available events

| Event name | Description                                                                                      |
| ---------- | ------------------------------------------------------------------------------------------------ |
| `select`   | The select event is emitted when the selectedDate or selectedTime computed properties are called |

## Basic Usage

```html
<smile-time-picker
	:legacyDesign="legacyDesign"
	:times="data"
	:config="config"
	v-model="selectedTime"
/>
```

# Smile Date Picker

Select a date for appointment.

### Available Props

| Prop      | Type   | Required/Optional | Default value | Description               |
| --------- | ------ | ----------------- | ------------- | ------------------------- |
| `dates`   | Array  | Required          | -             | Times to select.          |
| `v-model` | Number | Optional          | 0             | Selected time index.      |
| `config`  | Object | Optional          | -             | Component configurations. |

## Available events

| Event name | Description                                                                                      |
| ---------- | ------------------------------------------------------------------------------------------------ |
| `select`   | The select event is emitted when the selectedDate or selectedTime computed properties are called |

## Basic Usage

```html
<smile-date-picker :dates="data" :config="config" v-model="selectedDate" />
```
