# Smile Audio

Our `smile-audio` component uses the audio tag from HTML5 and it's attributes. https://developer.mozilla.org/en-US/docs/Web/HTML/Element/audio

## Available Props

| Prop                    | Type    | Required/Optional | Default value | Description                                                                                                                                                                                                           |
| ----------------------- | ------- | ----------------- | ------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `autoplay`              | Boolean | Optional          | `false`       | The audio will automatically begin playback as soon as it can do so, without waiting for the entire audio file to finish downloading.                                                                                 |
| `baseUrl`               | String  | Optional          | `CLOUDINARY`  | base URL                                                                                                                                                                                                              |
| `controls`              | Boolean | Optional          | `true`        | The browser will offer controls to allow the user to control audio playback, including volume, seeking, and pause/resume playback.                                                                                    |
| `disableRemotePlayback` | Boolean | Optional          | `false`       | Used to disable the capability of remote playback in devices that are attached using wired and wireless technologies. See this proposed specification for more information.                                           |
| `loop`                  | Boolean | Optional          | `false`       | If specified, the audio player will automatically seek back to the start upon reaching the end of the audio.                                                                                                          |
| `preload`               | String  | Optional          | `metadata`    | Provide a hint to the browser about what the author thinks will lead to the best user experience. `none:` Audio should not be preloaded. `metadata:` Audio metadata is fetched. `auto:` Audio file can be downloaded. |
| `projectName`           | String  | Required          | -             | Name of the file.                                                                                                                                                                                                     |

## Basic Usage

```html
<smile-audio
	:autoplay="autoplay"
	:controls="controls"
	:disableRemotePlayback="disableRemotePlayback"
	:loop="loop"
	:preload="preload"
	controlsList="nodownload"
	:src="audioName + '.mp3'"
/>
```
