# Smile Checkbox

This component is extended from Buefy's `smile-checkbox` component. https://buefy.org/documentation/checkbox

You can use checkboxes to retrieve a boolean value from your user, or even add multiple values to a shared context.

## Available Props

Prop | Type | Required/Optional | Default value | Description
| --- | --- | --- | --- | --- |
| `v-model` | Any | Optional | - | Binding value |
| `true-value` | Any | Optional | - | Overrides the return value when it's checked |
| `false-value` | Any | Optional | - | Overrides the return value when it's NOT checked |
| `name` | Any | Optional | - | Same as native HTML `name` property. |
| `native-value` | Any | Optional | - | Same as native HTML `value` property. |
| `disabled` | Boolean | Optional | - | Same as native HTML `disabled` property. |
| `legacy-design` | Boolean | Optional | `false` | Makes the component look like our legacy designs. |
| `required` | Boolean | Optional | - | Same as native HTML `required` property. |

## Basic Usage

``` html
<!-- Value is true/false by default -->
<smile-checkbox v-model="checkboxValue">
  A checkbox
</smile-checkbox>

<!-- Bind to custom values -->
<smile-checkbox
  v-model="checkboxCustomValue"
  true-value="Yes"
  false-value="No"
>
  {{ checkboxCustomValue }}
</smile-checkbox>
```

## Grouped Usage
``` html
<h1>How would you like to receive notificatons? Choose any that apply.</h1>
<smile-checkbox
  v-model="arrayOfNotificationOptions"
  native-value="Email"
>
  Email
</smile-checkbox>

<smile-checkbox
  v-model="arrayOfNotificationOptions"
  native-value="Text"
>
  Text
</smile-checkbox>

<smile-checkbox
  v-model="arrayOfNotificationOptions"
  native-value="Call"
>
  Call
</smile-checkbox>

<smile-checkbox
  v-model="arrayOfNotificationOptions"
  native-value="Snail Mail"
  disabled
>
  Snail Mail
</smile-checkbox>
```
