import {
  withKnobs, text, boolean, select,
} from '@storybook/addon-knobs';
import SmileCollapse from './smile-collapse.vue';
import componentDocs from './smile-collapse.md';

export default {
  title: 'Vue Components / SmileCollapse',
  decorators: [withKnobs({ escapeHTML: false })],
  parameters: {
    notes: { componentDocs },
  },
};

export const Default = () => ({
  components: { SmileCollapse },
  props: {
    isOpen: {
      type: Boolean,
      default: boolean('Prop: isOpen', false),
    },
    headerSlot: {
      type: String,
      default: text('Slot: #header', `<h2 class="has-text-weight-semibold has-text-black">Header slot content here</h2>`),
    },
    defaultSlot: {
      type: String,
      default: text('Default slot', `<p class="mb-5">Here is some <b>content</b> inside the default slot.</p> <ul class="mb-5"><li>Some</li><li>list</li><li>items</li></ul> <img src="https://via.placeholder.com/150" alt="placeholder image" />`),
    },
    removeContainer: {
      type: Boolean,
      default: boolean('Prop: removeContainer', false),
    },
    legacyDesign: {
      type: Boolean,
      default: boolean('Prop: legacyDesign', false),
    },
  },
  template: `
    <smile-collapse
      :isOpen="isOpen"
      :removeContainer="removeContainer"
      :legacyDesign="legacyDesign"
    >
      <template #header>
        <div v-html="headerSlot">
      </template>

      <div v-html="defaultSlot">
    </smile-collapse>
  `,
});
