# Smile Comparison Table

A component for rendering a wrapped Buefy table (b-table). It uses SmileComparisonTableColumns, which are wrapped (b-table-columns).

In the template, use <SmileComparisonTable> as the base element to return and pass into it as props


## Available Props

Prop | Type | Default value | Description
| --- | --- | --- | --- |
| `tableData` | Array | "[]" |  this determines the content of the td cells. |
| `loading` | Boolean | "false" | If true, displays loading overlay |

## Basic Usage

```
 <
  :tableData="tableData"
  :loading="loading"
 />
```

# Smile Comparison Table Column

The **SmileComparisonTable** component takes <SmileComparisonTableColumns> into slots.

## Available Props

Prop | Type | Default value | Description
| --- | --- | --- | --- |
| `headerClass and cellClass` | String | "" |  Generated by the computed properties in **boldClasses**, **highlightClasses**, and **plainClasses**. the string is identical for both headerClass and cellClass but must be provided for both in each column. |
| `field` | String | "" |  This is the name of the column. |
| `label` | String | "" | If text is provided in the label, that text will render in the column header. |
| `width` | String, Number | "" | Column fixed width in any unit, or pixels when none is provided. |
| `v-slot` | Object | "{}" | Is used to define an object that includes the data to be provided in that column. pass this data in between the opening/closing tags for the table column. |

## Basic Usage

```
	<smile-comparison-table-column
		field="bold"
		label=""
		:headerClass="boldClasses"
		:cellClass="boldClasses"
		v-slot="slotProps"
	>
		{{ slotProps.row.bold }}
	</smile-comparison-table-column>

```
