# Smile Comparison Table

Our `smile-comparison-table` component is based off of and extended from Buefy's `b-table` component. https://buefy.org/documentation/table - Most of the prop names match the Buefy documentation with the exception of a few.

## Available Props

| Prop               | Type    | Required/Optional | Default value | Description                                                   |
| ------------------ | ------- | ----------------- | ------------- | ------------------------------------------------------------- |
| `table-data`       | Array   | Required          | -             | An array of data to display in columns                        |
| `loading`          | Boolean | Optional          | `false`       | Shows a spinner while data is loading                         |
| `has-four-columns` | Boolean | Optional          | `false`       | Changes the width of columns depending if it has four columns |

## Basic Usage

```html
<smile-comparison-table
	:tableData="tableData"
	:loading="loading"
	:hasFourColumns="hasFourColumns"
>
	<b-table-column
		field="bold"
		label=""
		:headerClass="boldClasses"
		:cellClass="boldClasses"
		v-slot="slotProps"
	>
		{{ slotProps.row.bold }}
	</b-table-column>

	<b-table-column
		field="highlight"
		label=""
		:headerClass="highlightClasses"
		:cellClass="highlightClasses"
		v-slot="slotProps"
	>
		<template #header>
			<img :src="imageUrl" />
		</template>
		{{ slotProps.row.highlight }}
	</b-table-column>

	<b-table-column
		field="plain"
		label="Metal Braces"
		:headerClass="plainClasses"
		:cellClass="plainClasses"
		v-slot="slotProps"
	>
		{{ slotProps.row.plain }}
	</b-table-column>
	<b-table-column
		field="plain"
		label="Metal Braces"
		:headerClass="plainClasses"
		:cellClass="plainClasses"
		v-slot="slotProps"
	>
		{{ slotProps.row.plain }}
	</b-table-column>
</smile-comparison-table>
```
