# Smile Country Selector

A component for creating a country selector. It order country objects ordered by regions

## Available props

| Prop                     | Type             | Default                  | Description                                                                                                                                                                |
| ------------------------ | ---------------- | ------------------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `show`               | Boolean          |                          | Whether country selector is active or not, use the .sync modifier to make it two-way binding                                                                                          |
| `countries` | Array          | []                    | Array of country objects
| `legacy-design` | Boolean | Optional | `false` | Makes the component look like our legacy designs.
| `title` | String | `Select your region`  | Sets the title of  the country selector.                                                                                      |


## Available Events

Event | Description
| --- | --- |
| `@countryChange (country: Object)` | `Fires when user make click on any country` |
| `@close` | `Fires when the selector got closed` |

### Getting fancy
``` html
<smile-country-selector
  show.sync="showWithTwoWayBind"
  countries="countriesArray"
  @countryChange="onChangeFunction"
	legacyDesign
>
```

### Example country object

The min information the component needs is 'name', 'region', 'flag', 'locale',

``` js
{
  name: 'United States',
  locale: 'en-us',
  country_code_cookie: 'USA',
  region: 'North America',
  flag: 'US',
  language: 'English',
  isContentful: true,
  url: '/?country-chooser-choice=US',
},
```
