# Smile Select

This component is extended from Buefy's `this.$buefy.dialog.alert` method. https://buefy.org/documentation/dialog

Use dialog when your user needs to open an alert or confirmation modal.

## Available Props

Prop | Type | Required/Optional | Default value | Description
| --- | --- | --- | --- | --- |
| `visible` | Boolean | Required | - | Displays the dialog depending of it's type (Alert or confirm.). |
| `message:` | String | Required | `This is a dialog` | Message body of the dialog. |
| `title` | String | Optional | - | Dialog title. |
| `confirmText` | String | Optional | `Ok` | Text of the confirm button. |
| `cancelText` | String | Optional | `Cancel` | Text of the cancel button. |
| `type` | String | Required | `is-primary` | Type of the select `is-primary`, `is-white`, `is-black`, `is-light`, `is-dark`, `is-info`, `is-success`, `is-warning`, `is-danger`.   |
| `hasIcon` | Boolean | Optional | `false` | Adds an icon on the left side depending on the type or icon |
| `icon` | String | Optional | - | 	Icon name if hasIcon, optional  |
| `dialogType` | String | Required | `alert` |  Dialog type can be alert or confirm. |

## Available events

| Event name | Description                                                      |
| ---------- | ---------------------------------------------------------------- |
| `confirmed`    | The confirmed event is emitted when the dialog onConfirm method is called |
| `canceled`    | The canceled event is emitted when the dialog onCancel method is called |


## Basic Usage

```
<smile-dialog
	:visible="visible"
	:message="message"
	:title="title"
	:confirmText="confirmText"
	:cancelText="cancelText"
	:type="type"
	:hasIcon="hasIcon"
	:icon="icon"
	:dialogType="dialogType"
	@confirmed="confirmed"
	@canceled="canceled"
>
</smile-dialog>

```

## With Button

```
<div>
	<smile-dialog
		:visible="visible"
		:message="message"
		:title="title"
		:confirmText="confirmText"
		:cancelText="cancelText"
		:type="type"
		:hasIcon="hasIcon"
		:icon="icon"
		:dialogType="dialogType"
		@confirmed="confirmed"
		@canceled="canceled"
	>
	</smile-dialog>
	<smile-button
		:onClick="clicked"
		buttonSize="is-medium"
		buttonStyles="is-primary"
		buttonTag="button"
		buttonText="Click me"
	/>
</div>
```
