# Smile Field

The `<smile-field>` component is used to add functionality to controls and to attach/group components and elements together.

## Available props

| Prop             | Type    | Default value                          | Description                                                            |
| ---------------- | ------- | -------------------------------------- | ---------------------------------------------------------------------- |
| `label`          | String  | ''                                     | Field label.                                                           |
| `message`        | String  | 'Something went wrong with this field' | Help message text.                                                     |
| `helperText`     | String  | ''  												            | Helper text.                                                           |
| `labelFor`       | String  | ''                                     | Same as native for set on the label.                                   |
| `customClass`    | String  | ''                                     | CSS classes to be applied on field label.                              |
| `showMessage`    | Boolean | `false`                                | Displays the message text in the page.                                 |
| `showHelperText` | Boolean | `false`                                | Displays the helper text.                                              |
| `hideLabel`      | Boolean | `false`                                | Hide/Show the label without removing it from the DOM.                  |
| `grouped`        | Boolean | `false`                                | Direct child components/elements of Field will be grouped horizontally |
| `groupMultiline` | Boolean | `false`                                | Allow controls to fill up multiple lines, making it responsive.        |
| `legacyDesign`   | Boolean | `false`                                | Makes the component look like old Vulcan pages.                        |

## Usage examples

### Basic

``` html
<smile-field
  :type="type"
  :label="label"
  :label-for="labelFor"
  :custom-class="customClass"
  :message="displayMessage"
  :grouped="grouped"
  :group-multiline="groupMultiline"
>
  <slot/>
</smile-field>

```
