# Smile Flag

A component for rendering country flags in your Vue application.

Currently supported country codes are:
AU - CA - ES - FR - GB - HK - IE - MX - NZ - SG - US

To add a new flag, you'll need to add the new country code to the list created with the `$flag-countries-available` variable in our core SCSS file located at `src/scss/elements/flag.scss`.

## Available Props

Prop | Type | Default value | Description
| --- | --- | --- | --- |
| `code` | String | "us" | ISO 3166-1 identifier of the country, case insensitive. |
| `size` | String | "m" | Sets size of flag. Available options: "S", "M", "L" (case insensitive). |

## Basic Usage

``` html
<smile-flag code='us' />
<smile-flag code='gb' size='l' />
```
