import { withKnobs, text, select } from '@storybook/addon-knobs';
import SmileFlag from './smile-flag.vue';
import componentDocs from './smile-flag.md';

export default {
  title: 'Vue Components / SmileFlag',
  decorators: [withKnobs],
  parameters: {
    notes: { componentDocs },
  },
};

export const Default = () => ({
  components: { SmileFlag },
  props: {
    codeKnob: {
      type: String,
      default: select('code', ["AU", "CA", "ES", "FR", "GB", "HK", "IE", "MX", "NZ", "SG", "US"], 'US'),
    },
    sizeKnob: {
      type: String,
      default: select('size', ['S', 'M', 'L'], 'M'),
    },
  },
  template: `
    <smile-flag
      :code="codeKnob"
      :size="sizeKnob"
    />
  `,
});
