# Smile Hero

The `<smile-hero>` component is an imposing hero banner to showcase something.

## Available props

| Prop             | Type    | Default value                          | Description                                                            |
| ---------------- | ------- | -------------------------------------- | ---------------------------------------------------------------------- |
| `title`          | String  | ''                                     | Hero title.                                                           |
| `imageSrc`       | String  | ''                | Right image source
| `imageAlt`       | String  | ''  									  | Right image alt.                                                           |


## Usage examples

### Basic

``` html
 <smile-hero
        :title="title"
        :imageSrc="imageSrc"
        :imageAlt="imageAlt"
      >
        <template>
          <div class="has-text-black">
            <p>It's your first step to getting a smile you'll love. During your visit, a SmileGuide will take a 3D image of your current smile so you can see what your new smile will look like. And the best part is you only have to go once.</p>
            <br />
            <p> We ensure Smile Shops maintain all the required sanitizing, cleaning and hygienic measures before each appointment. Learn More.</p>
            <br />
            <p>If you still want to start from home, order an impression kit.</p>
          </div>
        </template>
 </smile-hero>

```

### Using custom content

``` html
 <smile-hero
        :title="title"
        :imageSrc="imageSrc"
        :imageAlt="imageAlt"
      >
        <template>
         <p>
					Use slot for custom content
				</p>
        </template>
 </smile-hero>
```
