# Smile Horizontal Slider

This is a wrapper component that enables you to wrap any set of direct children elements that you wish to overflow and slide horizontally. It makes no assumptions about the content you put inside it. The width of items and spacing between items is yours to define on the items.

NOTE: This component uses CSS Grid. For browser compatibility: https://caniuse.com/?search=grid

## Available Props

Prop | Type | Required/Optional | Default value | Description
| --- | --- | --- | --- | --- |
| `addArrows` | Boolean | Optional | `false` | Adds arrows that horizontally centered on each side of the slider. |
| `addScrollbar` | Boolean | Optional | `false` | Adds the browser native scrollbar to the bottom of the slider. |
| `addScrollSnap` | Boolean | Optional | `false` | Slider will always scroll the nearest item completely into view towards the left when a users "swipes" on the slider. Set to false if you wish to turn this off. |
| `addSmoothScroll` | Boolean | Optional | `false` | Slider will scroll with smooth behavior. Set to false if you wish to turn this off. |

## Basic Usage

### Bare miniumum
``` html
<smile-horizontal-slider>
	<item />
	<item />
	<item />
	<item />
	<item />
	<item />
	<item />
	...etc
</smile-horizontal-slider>
```

### Option town
``` html
<smile-horizontal-slider
  addArrows
  addScrollbar
  addScollSnap="false"
  addSmoothScroll
>
  <div v-for="(item, index) in someArray" :key="index">
    <some-component />
  </div>
</smile-horizontal-slider>
```
