# Smile Icon

This component uses Feather Icons: https://feathericons.com/ to render as an icon font through Buefy's b-icon component.

By default, a `<smile-icon />` will render at `24px` by `24px` with the color set by our default `body` font settings.

| Prop          | Type   | Required/Optional | Default value | Description                                                                                                                                                                                                                                                                                                                                                                                      |
| ------------- | ------ | ----------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `icon`        | String | Required          | -             | Required icon name passed in snake-case. Icons are from Feather Icon library and available names can be found here: https://feathericons.com/                                                                                                                                                                                                                                                    |
| `size`        | String | Optional          | -             | This prop sizes both the canvas/container and the icon element itself. Icons are 24px by 24px by default. Availabe size options: T-shirt sizes: `is-small` (12px), `is-medium` (16px), `is-large` (24px) - or Bulma size classes: `is-size-1` (36px), `is-size-2` (32px), `is-size-3` (28px), `is-size-4` (24px), `is-size-5` (20px), `is-size-6` (16px), `is-size-7` (14px), `is-size-8` (12px) |
| `type`        | String | Optional          | -             | Changes the color of the icon from the icon container. Availabe type options: `is-primary`, `is-black`, `is-dark`, `is-link`, `is-success`, `is-warning`, `is-danger`, `is-grey`                                                                                                                                                                                                                 |
| `customClass` | String | Optional          | -             | Pass a custom class to be added to the icon element inside the container. Size and color classes added here will override the icon element's settings from the `size` and `type` props. Note that using a size class here will change the icon size, but WILL NOT change the canvas size.                                                                                                        |

## Usage Examples

### Bare miniumum

```html
<smile-icon icon="settings" />
```

### Option town

This is an unrealistic design scenario. Just demonstrating all the props.

```html
<smile-icon
	icon="alert-triangle"
	size="is-large"
	type="is-danger"
	custom-class="is-size-3 has-background-light has-radius-large"
/>
```
