/* eslint-disable import/no-extraneous-dependencies */
import { storiesOf } from '@storybook/vue';

import { withKnobs, text, select } from '@storybook/addon-knobs';

import SmileIcon from './smile-icon.vue';
import componentDocs from './smile-icon.md';

storiesOf('Vue Components / SmileIcon', module)
  .addDecorator(withKnobs)
  .addParameters({ notes: { componentDocs } })
  .add(
    'Smile Icon component',
    () => ({
      components: { SmileIcon },
      props: {
        icon: {
          type: String,
          default: text('icon', 'settings'),
        },
        type: {
          type: String,
          default: select(
            'type',
            ['', 'is-primary', 'is-dark', 'is-black', 'is-link', 'is-success', 'is-warning', 'is-danger', 'is-grey'],
            ''
          ),
        },
        size: {
          type: String,
          default: select(
            'size',
            [
              '',
              'is-small',
              'is-medium',
              'is-large',
              'is-size-1',
              'is-size-2',
              'is-size-3',
              'is-size-4',
              'is-size-5',
              'is-size-6',
              'is-size-7',
              'is-size-8',
            ],
            ''
          ),
        },
        customClass: {
          type: String,
          default: text('customClass', ''),
        },
      },
      template: `
          <smile-icon :icon="icon" :type="type" :size="size" :customClass="customClass"></smile-icon>
      `,
    }),
    { info: true }
  );
