import { withKnobs, text } from '@storybook/addon-knobs';
import SmileIframe from './smile-iframe.vue';
import componentDocs from './smile-iframe.md';

export default {
  title: 'Vue Components / SmileIframe',
  decorator: [withKnobs],
  parameters: {
    notes: { componentDocs },
  },
};

export const DefaultIframe = () => ({
  components: { SmileIframe },
  props: {
    source: {
      type: String,
      default: text('Source URL', 'https://www.youtube.com/embed/tgbNymZ7vqY'),
    },
    title: {
      type: String,
      default: text('Title', 'Video'),
    },
    onLoad: {
      type: Function,
      default: () => {
        console.log('onLoad!');
      },
    },
  },
  template: `
    <div>
      <smile-iframe
        :source="source"
        :title="title"
        :onLoad="onLoad"
      >
      </smile-iframe>
    </div>
  `,
});
