# Smile Image

The `<smile-image>` component is extended from the `<b-image>` component in Buefy: https://buefy.org/documentation/image, and customized for our Design System. Only a subset of the functionality has been preserved. This component does not accept either the placeholder or the caption slots.

## Available props

| Prop                   | Type           | Required/Optional | Default value | Description                                                                  |
| ---------------------- | -------------- | ----------------- | ------------- | ---------------------------------------------------------------------------- |
| `src`                  | String         | Required          | --            | The image url you want to display.                                           |
| `srcset`               | String         | Optional          | ''            | You can enter a valid srcset value (ex. "image1.webp 400w,image2.webp 800w").|
| `alt`                  | String         | Required          | ''            | The image alternate text, if it cannot be displayed.                         |
| `lazy`                 | Boolean        | Optional          | false         | Use [IntersectionObserver](https://developer.mozilla.org/en-US/docs/Web/API/Intersection_Observer_API "IntersectionObserver docs") to display the image only when in viewport.|

## Usage examples

### With src

``` html
<smile-image
	:src="https://placekitten.com/1200/800"
	:alt="A kitten image"
	:lazy="true"
/>
```

### With srcset

``` html
<smile-image
	:src="https://placekitten.com/1200/800"
	:srcset="https://placekitten.com/300/200 300w,https://placekitten.com/600/400 600w,https://placekitten.com/1200/800 1200w"
	:alt="A kitten image"
	:lazy="true"
/>
```
