/* eslint-disable import/no-extraneous-dependencies */

import { storiesOf } from '@storybook/vue';
import markdown from './smile-image.md'

import {
  withKnobs,
  boolean,
  text,
} from '@storybook/addon-knobs';

import SmileImage from './smile-image.vue';

storiesOf('Vue Components / SmileImage', module)
  .addDecorator(withKnobs)
  .add('Smile Image with src component', () => ({
    components: { SmileImage },
    props: {
      src: {
        type: String,
        default: text('Src', 'https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcRQTX581lhg_sLIWEK9huBuigSOV8ew2ty4ZA&usqp=CAU'),
      },
      alt: {
        type: String,
        default: text('Alt', 'Visit to a SmileShop'),
      },
      lazy: {
        type: Boolean,
        default: boolean('Lazy loading', false),
      },
    },
    template: `
      <smile-image
        :src="src"
        :alt="alt"
        :lazy="lazy"
      />
    `,
  }),
    {
      notes: { markdown },
    }
  )
  .add('Smile Image with srcset component', () => ({
    components: { SmileImage },
    props: {
      src: {
        type: String,
        default: text('Src', 'https://placekitten.com/1200/800'),
      },
      srcset: {
        type: String,
        default: text('Srcset', 'https://placekitten.com/300/200 300w,https://placekitten.com/600/400 600w,https://placekitten.com/1200/800 1200w'),
      },
      alt: {
        type: String,
        default: text('Alt', 'A nice kitty'),
      },
      lazy: {
        type: Boolean,
        default: boolean('Lazy loading', false),
      },
    },
    template: `
      <smile-image
        :src="src"
        :srcset="srcset"
        :alt="alt"
        :lazy="lazy"
      />
    `,
  }),
    {
      notes: { markdown },
    }
  );
