import { withKnobs, boolean } from '@storybook/addon-knobs';
import SmileLogo from './smile-logo.vue';
import componentDocs from './smile-logo.md';

export default {
  title: 'Vue Components / SmileLogo',
  decorators: [withKnobs],
  parameters: {
    notes: { componentDocs },
    layout: 'fullscreen',
  },
};

export const Logo = () => ({
  components: { SmileLogo },
  props: {
    minimal: {
      type: Boolean,
      default: boolean('Minimal', false),
    },
  },
  template: `
    <smile-logo
      :minimal="minimal"
      height="100"
    />
  `,
});
