# Smile Media Card

A robust component for creating different variations of "cards" an image/media on top, and other content below.

## Available props

| Prop                          | Type    | Default | Description                                                                                                                                                              |
| ----------------------------- | ------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `title`                       | String  |         | Optional title that will appear below the image and above any custom content                                                                                             |
| `imageSrc`                    | String  | ""      | Path to image file                                                                                                                                                       |
| `imageAlt`                    | String  | ""      | Provide description of image for screen readers. If image description provides no contextual value, leave empty(default) as this tells screen readers to skip the image. |
| `containerUrl`                | String  | ""      | Creates a link for the full card. If no link is desired, leave empty.                                                                                                    |
| `hasRoundedImage`             | Boolean | false   | Makes the image a circle instead of taking up the full width of the top of the card.                                                                                     |
| `imageContainerCustomClass`   | String  |         | Add any custom classes you would like applied to the container that wraps the image                                                                                      |
| `contentContainerCustomClass` | String  |         | Add any custom classes you would like applied to the container that wraps the card content                                                                               |
| `footerContainerCustomClass`  | String  |         | Add any custom classes you would like applied to the container that wraps the footer                                                                                     |

## Available custom slots

| Slot name      | Description                                                                                                                   | Props (if scoped) |
| -------------- | ----------------------------------------------------------------------------------------------------------------------------- | ----------------- |
| `card-video`   | Optional custom video element.                                                                                                |                   |
| `card-image`   | Optional custom image element. Providing an image here will make `imageSrc`, `hasRoundedImage`, and `imageAlt` to be ignored. |                   |
| `card-content` | Places content below the image, and above the footer (if present)                                                             |                   |
| `card-footer`  | Custom footer at the bottom of the card, below all other content.                                                             |                   |
