# Smile Loading

The `<smile-navbar>` component renders the top, responsive, site navigation bar.


## Available props

Prop | Type | Default value | Description
| --- | --- | --- | --- |
| `withUtilityBar` | Boolean | true | If set to `false` the utility (top) bar won-t be displayed. |
| `logoPartDirectClub` | Boolean | true | Displays the "Direct Club" portion of thge logo. |
| `logoHref` | String | "https://smiledirectclub.com/" | Target url when clicking on the logo. |
| `amIACandidateHref` | String | "https://smiledirectclub.com/smile_assessment/" | Target url when clicking on "Am I a candidate?" buttons. |
| `bodyOverlay` | Boolean | true | Enables overlay on the page and prevents scrolling when the mobile menu is open.  This sets and removes (destructively) styles over the `body` tag of the document.  It might cause page issues in some implementations, so it can be srt to `false` but in that case, user interaction should be restricted by other means. |
| `utilityCountryCode` | String | "US" | Flag and country code in the utility bar. |
| `utilityPhoneNumber` | String | "1-800-848-7566" | Phone number (and link). |
| `mainNavbarItems` | Array | [] | Data structure for the main navigation lins.  E.g.: `[{ key: 1, text: 'Why SDC?', href: 'https://smiledirectclub.com/why-smile-direct-club/', targetBlank: true }]` |
| `isSideBarMenu` | Boolean | false | Hide horizontal menu for desktop and tablet |


## Events
Event | Description
| --- | --- |
| `@onClickCountryFlag` | Fired when clkicking on utility navigation flag. |
| `@onClickLiveChat` | Fired when clkicking on live chat button. |
| `@onClickSignIn` | Fired when clkicking on sign in button. |
| `@onClickGetStarted` | Fired when clkicking on get started button. |


## Usage example

``` html
<smile-navbar
	:with-utility-bar="true"
	:logo-part-direct-club="logoPartDirectClub"
	logo-href="https://smiledirectclub.com/"
	am-i-a-candidate-href="https://smiledirectclub.com/smile_assessment/"
	:body-overlay="true"
	:utility-country-code="US"
	:utility-phone-number="1-800-848-7566"
	:main-navbar-items="[{ key: 1, text: 'Why SDC?', href: 'https://smiledirectclub.com/why-smile-direct-club/', targetBlank: true }]"
	:isSideBarMenu="false"
	@onClickCountryFlag="handleCountryFlag"
	@onClickLiveChat="handleLivChat"
	@onClickSignIn="handleSignIn"
	@onClickGetStarted="handleGetStarted"
/>
```
