/* eslint-disable import/no-extraneous-dependencies */
import { storiesOf } from '@storybook/vue';

import { withKnobs, select, number } from '@storybook/addon-knobs';

import SmilePagination from './SmilePagination.vue';
import componentDocs from './smile-pagination.md';

storiesOf('Vue Components / SmilePagination', module)
  .addParameters({ notes: { componentDocs } })
  .addDecorator(withKnobs)
  .add(
    'Smile Pagination component',
    () => ({
      components: { SmilePagination },
      data() {
        return {
          currentPage: 2,
        };
      },
      props: {
        size: {
          type: String,
          default: select('Size', ['is-large', 'is-medium', 'is-small'], 'is-small'),
        },
        perPage: {
          type: Number,
          default: number('Per page', 5, { min: 1 }),
        },
        total: {
          type: Number,
          default: number('Total', 25, { min: 1 }),
        },
      },
      template: `
        <smile-pagination
          v-model="currentPage"
          :per-page="perPage"
          :size="size"
          :total="total"/>
      `,
    }),
    { info: true }
  );
