# Smile Pagination

This component is extended from Buefy's `b-pagination` component. https://buefy.org/documentation/pagination.

Use this component when you need a component that displays controls for a paginator to show the user in what page they're and how many are left.

## Available props

| Prop      | Type   | Required / Optional | Default value | Description                                                                                             |
| --------- | ------ | ------------------- | ------------- | ------------------------------------------------------------------------------------------------------- |
| `perPage` | Number | Optional            | 20            | It's used to calculate how many pages will be shown to the user.                                        |
| `size`    | String | Optional            | `'is-small'`  | The size class assigned to the pagination component.                                                    |
| `total`   | Number | Optional            | 0             | The amount of pages that are available. The component will not show unless its value is greater than 0. |
| `value`   | Number | Required            | 1             | This is a required property. It's used to control what is the current page using v-model.               |

## Available events

| Event name | Description                                                                                                                                                   |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `input`    | Emitted on every update of the `pageHandler` computed property with the new value being set. The value passed in the payload is the new page number we're on. |

## Usage examples

### Basic

```html
<smile-pagination
	v-model="currentPage"
	:per-page="perPage"
	:size="size"
	:total="total"
/>
```
