# Smile Progress Bar

This component is extended from Buefy's `b-progress` component. https://buefy.org/documentation/progress

Use this component when your user needs to know that a task in under progress. Additionally, you can report how much of that task has been completed.

## Available Props

| Prop            | Type    | Required/Optional | Default value | Description                                                                                                                                                                                                                                                                                             |
| --------------- | ------- | ----------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `value`         | Number  | Optional          | 50            | The progress value, progress will be indeterminate if undefined.                                                                                                                                                                                                                                        |
| `size`          | String  | Required          | `is-small`    | Size of the select `is-small`, `is-medium`, `is-large`.                                                                                                                                                                                                                                                 |
| `max`           | Number  | Required          | 100           | The maximum value for the progress bar.                                                                                                                                                                                                                                                                 |
| `indeterminate` | Boolean | Required          | -             | A progress bar is "indeterminate" when it is not filled-up based on what percentage of the maximum value our current value represents. Instead, it shows an animation to convey this state. Even if a `value` is passed, if this prop is `true`, the progress bar will have the indeterminate behavior. |

## Basic Usage

```html
<smile-progress-bar
	size="is-medium"
	:value="value"
	:max="max"
	:indeterminate="false"
/>
```
