/* eslint-disable import/no-extraneous-dependencies */
import { storiesOf } from '@storybook/vue';

import { withKnobs, select, number, boolean } from '@storybook/addon-knobs';

import SmileProgressBar from './smile-progress-bar.vue';
import componentDocs from './smile-progress-bar.md';

storiesOf('Vue Components / SmileProgressBar', module)
  .addParameters({ notes: { componentDocs } })
  .addDecorator(withKnobs)
  .add(
    'Smile Progress Bar component',
    () => ({
      components: { SmileProgressBar },
      props: {
        value: {
          type: Number,
          default: number('value', 80),
        },
        size: {
          type: String,
          default: select('Size', ['is-large', 'is-medium', 'is-small'], 'is-large'),
        },
        max: {
          type: Number,
          default: number('max', 100),
        },
        indeterminate: {
          type: Boolean,
          default: boolean('Indeterminate', false),
        },
      },
      template: `
          <smile-progress-bar :value="value" :size="size" :max="max" :indeterminate="indeterminate"></smile-progress-bar>
      `,
    }),
    { info: true }
  );
