import SmileProgressWheel from './smile-progress-wheel.vue';
import componentDocs from './smile-progress-wheel.md';
import {
  select,
  text
} from '@storybook/addon-knobs';
export default {
  title: 'Vue Components / SmileProgressWheel',
  parameters: {
    notes: { componentDocs },
  },
};

export const Basic = () => ({
  components: { SmileProgressWheel},
  props: {
    totalSteps: {
      type: Number,
      default: select('totalSteps', [7, 14]),
    },
    stepsLeft: {
      type: Number,
      default: select('stepsLeft', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], 5),
    },
    headerText: {
      type: String,
      default: text('headerText', 'Aligner switch in')
    },
    footerText: {
      type: String,
      default: text('footerText', 'Thursday, Dec 19th'),
    },
    measurementType: {
      type: String,
      default: text('measurementType', 'day'),
    }
  },
  template: `
    <div>
      <smile-progress-wheel
        :total-steps="totalSteps"
        :steps-left="stepsLeft"
        :header-text="headerText"
        :footer-text="footerText"
        :measurement-type="measurementType"
      />
    </div>
  `,
});
