/* eslint-disable import/no-extraneous-dependencies */
import { storiesOf } from '@storybook/vue';

import { withKnobs, number, text } from '@storybook/addon-knobs';

import SmileStarRating from './smile-star-rating.vue';
import componentDocs from './smile-star-rating.md';

storiesOf('Vue Components / SmileStarRating', module)
  .addParameters({ notes: { componentDocs } })
  .addDecorator(withKnobs)
  .add(
    'Smile Star Rating component',
    () => ({
      components: { SmileStarRating },
      props: {
        value: {
          type: Number,
          default: number('value', 5),
        },
        text: {
          type: String,
          default: text('text', '7469 Reviews'),
        },
      },
      template: `
          <smile-star-rating :value="value" :text="text"></smile-star-rating>
      `,
    }),
    { info: true }
  );
