/* eslint-disable import/no-extraneous-dependencies */
import { storiesOf } from '@storybook/vue';

import { action } from '@storybook/addon-actions';
import { withKnobs, text, select, boolean } from '@storybook/addon-knobs';

import SmileStepsItem from './smile-steps-item.vue';
import SmileSteps from './smile-steps.vue';
import componentDocs from './smile-steps.md';

storiesOf('Vue Components / SmileStepsItem', module)
  .addParameters({ notes: { componentDocs } })
  .addDecorator(withKnobs)
  .add(
    'Smile Steps Item component',
    () => ({
      components: { SmileSteps, SmileStepsItem },
      props: {
        step: {
          type: String,
          default: text('step', '1'),
        },
        label: {
          type: String,
          default: text('label', 'Summary'),
        },
        clickable: {
          type: Boolean,
          default: boolean('clickable', true),
        },
      },
      template: `
        <smile-steps
          type="is-primary"
          size="is-medium"
          label-position="bottom"
        >
          <smile-steps-item
            :step="step"
            :label="label"
            :clickable="clickable"
          ></smile-steps-item>
        </smile-steps>
    `,
    }),
    { info: true }
  );
