# Smile Steps

This component is extended from Buefy's `b-steps` component. https://buefy.org/documentation/steps/

Responsive horizontal process steps.

## Available Props

| Prop            | Type             | Required/Optional | Default value | Description                                                                                                                                        |
| --------------- | ---------------- | ----------------- | ------------- | -------------------------------------------------------------------------------------------------------------------------------------------------- |
| `value`         | [String, Number] | Optional          | `0`           | v-model value.                                                                                                                                     |
| `type`          | String           | Optional          | `is-primary`  | type of the step `'is-white'`, `'is-black'`, `'is-light'`, `'is-dark'`, `'is-primary'`, `'is-info'`, `'is-success'`, `'is-warning'`, `'is-danger'` |
| `size`          | String           | Optional          | `is-small`    | Size of the step. `'is-small', 'is-medium', 'is-large'`                                                                                            |
| `labelPosition` | String           | Optional          | `bottom`      | Position of the marker label. `'bottom', 'right', 'left'`                                                                                          |
| `mobileMode`    | String           | Required          | minimalist    | How Steps will be displayed for mobile user. `'minimalist', 'compact', 'null'`                                                                     |
| `hasNavigation` | Boolean          | Optional          | `false`       | Next and previous buttons below the component. You can use this property if you want to use your own custom navigation items.                      |
| `legacyDesign`  | Boolean          | Optional          | false         | Makes the component look like old Vulcan pages.                                                                                                    |

## Available events

| Event name           | Description                                                                        |
| -------------------- | ---------------------------------------------------------------------------------- |
| `activeStepSelected` | The activeStepSelected event is emitted when the model computed property is called |

# Smile Steps Item

This component is extended from Buefy's `b-step-item` component. https://buefy.org/documentation/steps/

## Available Props

| Prop        | Type    | Required/Optional | Default value | Description                                                                                                 |
| ----------- | ------- | ----------------- | ------------- | ----------------------------------------------------------------------------------------------------------- |
| `step`      | String  | Required          | -             | Step marker content (when there is no icon).                                                                |
| `clickable` | Boolean | Optional          | -             | Item can be used directly to navigate. If undefined, previous steps are clickable while the others are not. |
| `label`     | String  | Required          | -             | Step label.                                                                                                 |

## Basic Usage

```html
<smile-steps>
	v-model="activeStep" :animated="isAnimated" :rounded="isRounded"
	:has-navigation="hasNavigation" :icon-prev="prevIcon" :icon-next="nextIcon"
	:label-position="labelPosition" :mobile-mode="mobileMode">
	<smile-steps-item step="1" label="Account"></smile-steps-item>
	<smile-steps-item step="2" label="Profile"></smile-steps-item>
	<smile-steps-item step="3" label="Social"></smile-steps-item>
</smile-steps>
```
