# Smile Tabs

Our `smile-tabs` component is based off of and extended from Buefy's `b-tabs` component. https://buefy.org/documentation/tabs

## Available Props

| Prop       | Type             | Required/Optional | Default value | Description                                           |
| ---------- | ---------------- | ----------------- | ------------- | ----------------------------------------------------- |
| `v-model`  | Number           | Optional          | 0             | Selected tab index.                                   |
| `value`    | [String, Number] | Optional          | -             | Tab index position.                                   |
| `size`     | String           | Optional          | `'is-small'`  | Size of the tabs `is-small`, `is-medium`, `is-large`. |
| `position` | String           | Optional          | ''            | Position of the tab. `'', 'is-centered', 'is-right'`  |

## Available events

| Event name         | Description                                                                      |
| ------------------ | -------------------------------------------------------------------------------- |
| `activeTabChanged` | The activeTabChanged event is emitted when the model computed property is called |

# Smile Tab Item

Our `smile-tab-item` component is based off of and extended from Buefy's `b-tab-item` component. https://buefy.org/documentation/tabs

## Available Props

| Prop       | Type    | Required/Optional | Default value | Description          |
| ---------- | ------- | ----------------- | ------------- | -------------------- |
| `label`    | String  | Required          | -             | Text of the tab item |
| `disabled` | Boolean | Optional          | -             | Disable tab item     |

## Basic Usage

```html
<smile-tabs
	v-model="activeTab"
	:size="size"
	:label="tabLabel"
	:position="position"
	:disableTab="disableTab"
>
	<smile-tab-item label="Label 1" :disabled="false" />
	<smile-tab-item label="Label 2" :disabled="false" />
	<smile-tab-item :label="tabLabel" :disabled="disableTab" />
</smile-tabs>
```
