/* eslint-disable import/no-extraneous-dependencies */

import { storiesOf } from '@storybook/vue';

import { action } from '@storybook/addon-actions';
import { withKnobs, select, boolean, text } from '@storybook/addon-knobs';

import SmileTag from './smile-tag.vue';
import componentDocs from './smile-tag.md';

storiesOf('Vue Components / SmileTag', module)
  .addParameters({ notes: { componentDocs } })
  .addDecorator(withKnobs)
  .add(
    'Smile Tag component',
    () => ({
      components: { SmileTag },
      props: {
        text: {
          type: String,
          default: text('Text', 'This is example text'),
        },
        type: {
          type: String,
          default: select(
            'Type',
            [
              'is-primary',
              'is-white',
              'is-black',
              'is-dark',
              'is-light',
              'is-link',
              'is-info',
              'is-warning',
              'is-danger',
            ],
            'is-primary'
          ),
        },
      },
      template: `
        <smile-tag :type="type" >{{text}}</smile-tag>
    `,
    }),
    { info: true }
  );
