# Smile Tel Input

Our `smile-tel-input` component is based from `vue-te-input` component https://iamstevendao.github.io/vue-tel-input/documentation/getting-started.html.

## Available Props

Prop | Type | Required/Optional | Default value | Description
| --- | --- | --- | --- | --- |
| `allCountries` | Array | Optional | `array with countries`<br> `of allCountries.js`| Countries displayed. |
| `autoFormat` | Boolean | Optional | `true` | Auto update the input to the formatted phone number when it's valid. |
| `customValidate` | Boolean, RegExp | Optional | `false` | Custom validation RegExp for input. |
| `defaultCountry` | String, Number | Optional | `''`| Default country (by iso2 or dialCode), will override the country fetched from IP address of user. |
| `disabled` | Boolean | Optional | `false` | Disable the input. |
| `autoDefaultCountry` | Boolean | Optional | `true` | fetch default country based on IP address of user. |
| `dropdownOptions` | Object | Optional | `See below` | options for dropdown. |
| `dropdownOptions.showDialCodeInList` | Boolean | Optional | `true` | Show dial code in the dropdown list. |
| `dropdownOptions.showDialCodeInSelection` | Boolean | Optional | `false` | Show dial code in the dropdown selection. |
| `dropdownOptions.showFlags` | Boolean | Optional | `true` | Show flags in the dropdown selection and list. |
| `dropdownOptions.tabindex` | Number | Optional | `0` | Native dropdown tabindex attribute. |
| `ignoredCountries` | Array | Optional | `[]` | List of countries will NOT be shown on the dropdown. |
| `inputOptions` | Object | Optional | `See below` | Options for input. |
| `inputOptions.autocomplete` | String | Optional | `'on'` | Native input autocomplete attribute. |
| `inputOptions.autofocus` | Boolean | Optional | `false` | Native input autofocus attribute. |
| `inputOptions.aria-describedby` | String | Optional | `''` | Native input aria-describedby attribute. |
| `inputOptions.id` | String | Optional | `''` | Native input id attribute. |
| `inputOptions.maxlength` | Number | Optional | `25` | Native input maxlength attribute. |
| `inputOptions.name` | String | Optional | `'telephone'` | Native input name attribute. |
| `inputOptions.placeholder` | String | Optional | `'Enter a phone number'` | Placeholder for the input. |
| `inputOptions.readonly` | Boolean | Optional | `false` | Native input readonly attribute. |
| `inputOptions.required` | Boolean | Optional | `false` | Native input required attribute. |
| `inputOptions.tabindex` | Number | Optional | `0` | Native input tabindex attribute. |
| `inputOptions.type` | String | Optional | `'tel'` | Native input type attribute. |
| `inputOptions.styleClasses` | String, Array, Object | Optional | `''` | Custom classes for the input. |
| `mode` | String | Optional | `'auto'` | Allowed values: 'auto' (Default set by phone), 'international' (Format number with the dial code i.e. + 61), 'national' (Format number without dial code i.e. 0321232). |
| `onlyCountries` | Array | Optional | `[]` | List of countries will be shown on the dropdown. |
| `preferredCountries` | Array | Optional | `[]` | Preferred countries list, will be on top of the dropdown. |
| `styleClasses` | String, Array, Object | Optional | `''` | Custom classes for the wrapper. |

## Available Events

Event | Description
| --- | --- |
| `@input (number: String, phoneObject: Object)` | `Fires when the input changes.` |
| `@validate (phoneObject: Object)` | `Fires when the correctness of the phone number changes (from`<br> `true to false or vice-versa) and when the`<br> `component is mounted.` |
| `@country-changed (countryObject: Object)` | `Fires when country changed (even for the first time).` |
| `@blur` | `Fires on blur event.` |
| `@focus` | `Fires on focus event.` |
| `@space` | `Fires on keyup.space event.` |
| `@enter` | `Fires on keyup.enter event.` |
| `@open` | `Fires when the flags dropdown opens.` |
| `@close` | `Fires when the flags dropdown closes.` |
## Basic Usage
### Default
``` html
<smile-tel-input/>
```

### Showing error style
``` html
<smile-tel-input
  class="is-danger"
/>
```

