# Smile Time Slot Picker

Our `smile-time-slot-picker` component allows you to place a time picker on the page.

## Available Props

| Prop                  | Type   | Required/Optional | Default value | Description                                                                                                                                                                                                                                                                                                                                                                                                                           |
| --------------------- | ------ | ----------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `timeSlots`           | Array  | Required          |               | An array of time slots objects with the following attributes.<br/><li> `appointmentStartTime`: A time string in the format: `hh:mm:ss`. This is the time the appointment begins in the locality of the SmileShop.</li><li> `appointmentUTCTime`: A date time string in the format: `YYYY-MM-DDThh:mm:ssZ`</li><li> `availableAppointments`: A number representing the total number of appointments available for that time slot.</li> |
| `initialSelectedSlot` | String |                   |               | The initial time slot that should be selected. Should be a string in the format: `YYYY-MM-DDThh:mm:ssZ`                                                                                                                                                                                                                                                                                                                               |

## Available Events

| Event                                | Description                                                                                       |
| ------------------------------------ | ------------------------------------------------------------------------------------------------- |
| `@slotChanged (string: date string)` | Fires when user selects a new time slot. Provides the date string associated with that time slot. |

## Basic Usage

### Default

```html
<smile-time-slot-picker />
```
