# Smile Toast

Our `smile-toast` component is based off of and extended from Buefy's `Toast` component. https://buefy.org/documentation/toast/

## Available Props

| Prop       | Type    | Required? | Default value      | Description                                                                                                                                        |
| ---------- | ------- | --------- | ------------------ | -------------------------------------------------------------------------------------------------------------------------------------------------- |
| `type`     | String  |           | `is-dark`(Blurple) | Color variant of the toast.                                                                                                                        |
| `message`  | String  | X         | `''`               | Toast message body text.                                                                                                                           |
| `position` | String  |           | `is-top`           | Which position the toast will appear. Available options: `is-top-right`, `is-top`, `is-top-left`, `is-bottom-right`, `is-bottom`, `is-bottom-left` |
| `duration` | Number  |           | `2000`             | Visibility duration in milliseconds                                                                                                                |
| `queue`    | Boolean |           | `undefined`        | If should queue with others notices (snackbar/toast/notification)                                                                                  |
| `show`     | Boolean |           | `undefined`        | Whether or not the toast is open/visible.                                                                                                          |

## Basic Usage

### Default

```html
<div>
	<smile-toast
		:message="message"
		:queue="queue"
		:duration="duration"
		:type="type"
		:position="position"
		:show="show"
		@finish="finish"
	></smile-toast>
	<smile-button
		:onClick="onClick"
		buttonSize="is-medium"
		buttonStyles="is-primary"
		buttonTag="button"
		buttonText="Click me"
	/>
</div>
```

## Available events

| Event name | Description                                                            |
| ---------- | ---------------------------------------------------------------------- |
| `finish`   | The finish event is emitted when the toast show method has been called |
