# .is-fullheight-[breakpoint] Helper Class

`.is-fullheight-[breakpoint]` helper classes extend Bulma's breakpoints and mixins to create additional helper classes which adds `100vh` to the breakpoint used.

- Bulma Responsive Breakpoints: https://bulma.io/documentation/overview/responsiveness/
- Bulma Responsive Mixins: https://bulma.io/documentation/utilities/responsive-mixins/

| Class Name                        | Description                        |
| --------------------------------- | ---------------------------------- |
| `.is-fullheight`                  | full-height on all screen sizes    |
| `.is-fullheight-mobile`           | (max-width) until 768px and below  |
| `.is-fullheight-touch`            | (max-width) until 1023px and below |
| `.is-fullheight-desktop`          | (min-width) from 1024px and above  |
| `.is-fullheight-widescreen`       | (min-width) from 1216px and above  |
| `.is-fullheight-fullhd`           | (min-width) from 1408px and above  |
| `.is-fullheight-tablet-only`      | between 769px and 1023px           |
| `.is-fullheight-desktop-only`     | between 1024px and 1215px          |
| `.is-fullheight-widescreen-only`  | between 1216px and 1407px          |
| `.is-fullheight-until-widescreen` | (max-width) from 1216px and below  |
| `.is-fullheight-until`            | (max-width) from 1408px and below. |
