# .is-fullwidth-[breakpoint] Helper Class

`.is-fullwidth-[breakpoint]` helper classes extend Bulma's breakpoints and mixins to create additional helper classes which adds `100%` to the breakpoint used.

- Bulma Responsive Breakpoints: https://bulma.io/documentation/overview/responsiveness/
- Bulma Responsive Mixins: https://bulma.io/documentation/utilities/responsive-mixins/

| Class Name                       | Description                       |
| -------------------------------- | --------------------------------- |
| `.is-fullwidth`                  | full-width on all screen sizes    |
| `.is-fullwidth-mobile`           | (max-width) until 768px           |
| `.is-fullwidth-tablet`           | (min-width) from 769px and above  |
| `.is-fullwidth-desktop`          | (min-width) from 1024px and above |
| `.is-fullwidth-widescreen`       | (min-width) from 1216px and above |
| `.is-fullwidth-fullhd`           | (min-width) from 1408px and above |
| `.is-fullwidth-tablet-only`      | between 769px and 1023px          |
| `.is-fullwidth-desktop-only`     | between 1024px and 1215px         |
| `.is-fullwidth-widescreen-only`  | between 1216px and 1407px         |
| `.is-fullwidth-touch`            | (max-width) until 1023px          |
| `.is-fullwidth-until-widescreen` | (max-width) until 1215px          |
| `.is-fullwidth-until-fullhd`     | (max-width) until 1407px          |

## Basic Usage

```html
<div class="is-fullwidth"></div>
```
