import { storiesOf } from '@storybook/vue';

// import component docs
import componentDocs from './text-docs.md';
import allTextTemplate from './all-text.vue';

storiesOf('HTML & CSS / Elements / Titles and Text', module)
  .addParameters({
    notes: componentDocs
  })
  .add('All Text Components', () => (allTextTemplate))
  .add('Title 1', () => (`<h1 class="title is-1">A title 1 you'll love for less than $3 per day</h1>`))
  .add('Title 2', () => (`<h2 class="title is-2">A title 2 you'll love for less than $3 per day</h2>`))
  .add('Title 3', () => (`<h3 class="title is-3">A title 3 you'll love for less than $3 per day</h3>`))
  .add('Title 4', () => (`<h4 class="title is-4">A title 4 you'll love for less than $3 per day</h4>`))
  .add('Title 5', () => (`<h5 class="title is-5">A title 5 you'll love for less than $3 per day</h5>`))
  .add('Title 6', () => (`<h6 class="title is-6">A title 6 you'll love for less than $3 per day</h6>`))
  .add('Eyebrow', () => (`<p class="eyebrow">Eyebrow</p>`))
  .add('Body', () => (`<p>Body: Here is some body text. It should be used to make paragraphs. A paragraph has at least two or three sentences, right?</p>`))
  .add('Small body', () => (`<p class="is-size-7">Small text...Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse optio laborum itaque ab expedita reprehenderit enim dicta, ratione sint magni tempora, consequatur molestiae facilis consequuntur, excepturi vero! Optio, nobis sed.</p>`))
  .add('Extra small caption/footnote', () => (`<p class="is-size-8">Extra small text...Lorem ipsum dolor sit amet, <a href="#">consectetur adipisicing elit</a>. Esse optio laborum itaque ab expedita reprehenderit enim dicta, ratione sint magni tempora, consequatur molestiae facilis consequuntur, excepturi vero! Optio, nobis sed.</p>`))
