import Vue from 'vue';
import Buefy from 'buefy';

// Global design system style import
import './scss/sdc-base.scss';

// Alphabetical import of each component to be added to the libarary
import SmileAppointmentScheduler from './components/smile-appointment-scheduler/smile-appointment-scheduler.vue';
import SmileAudio from './components/smile-audio/smile-audio.vue';
import SmileButton from './components/smile-button/SmileButton.vue';
import SmileCheckbox from './components/smile-checkbox/smile-checkbox.vue';
import SmileCollapse from './components/smile-collapse/smile-collapse.vue';
import SmileCountrySelector from './components/smile-country-selector/smile-country-selector.vue';
import SmileDialog from './components/smile-dialog/smile-dialog.vue';
import SmileDropdown from './components/smile-dropdown/smile-dropdown.vue';
import SmileDropdownItem from './components/smile-dropdown/smile-dropdown-item.vue';
import SmileField from './components/smile-field/smile-field.vue';
import SmileFlag from './components/smile-flag/smile-flag.vue';
import SmileHorizontalSlider from './components/smile-horizontal-slider/smile-horizontal-slider.vue';
import SmileHero from './components/smile-hero/smile-hero.vue';
import SmileIcon from './components/smile-icon/smile-icon.vue';
import SmileIframe from './components/smile-iframe/smile-iframe.vue';
import SmileImage from './components/smile-image/smile-image.vue';
import SmileInput from './components/smile-input/smile-input.vue';
import SmileLoading from './components/smile-loading/smile-loading.vue';
import SmileLogo from './components/smile-logo/smile-logo.vue';
import SmileMediaCard from './components/smile-media-card/smile-media-card.vue';
import SmileMessage from './components/smile-message/smile-message.vue';
import SmileModal from './components/smile-modal/smile-modal.vue';
import SmileNavbar from './components/smile-navbar/smile-navbar.vue';
import SmileNotification from './components/smile-notification/smile-notification.vue';
import SmilePagination from './components/smile-pagination/SmilePagination.vue';
import SmileProgressBar from './components/smile-progress-bar/smile-progress-bar.vue';
import SmileProgressWheel from './components/smile-progress-wheel/smile-progress-wheel.vue';
import SmileRadio from './components/smile-radio/smile-radio.vue';
import SmileSelect from './components/smile-select/smile-select.vue';
import SmileStarRating from './components/smile-star-rating/smile-star-rating.vue';
import SmileSteps from './components/smile-steps/smile-steps.vue';
import SmileTabs from './components/smile-tabs/smile-tabs.vue';
import SmileTag from './components/smile-tag/smile-tag.vue';
import SmileTelInput from './components/smile-tel-input/smile-tel-input.vue';
import SmileTimeSlotPicker from './components/smile-time-slot-picker/SmileTimeSlotPicker.vue';
import SmileToast from './components/smile-toast/smile-toast.vue';
import SmileTooltip from './components/smile-tooltip/smile-tooltip.vue';
import SmileVideo from './components/smile-video/smile-video.vue';

// Initialize global Buefy framework/components
Vue.use(Buefy, {
  customIconPacks: {
    fe: {
      iconPrefix: 'fe-',
    },
  },
});

const SdcComponentLibrary = {
  SmileAppointmentScheduler,
  SmileAudio,
  SmileButton,
  SmileCheckbox,
  SmileCollapse,
  SmileCountrySelector,
  SmileDialog,
  SmileDropdown,
  SmileDropdownItem,
  SmileField,
  SmileFlag,
  SmileHorizontalSlider,
  SmileHero,
  SmileIcon,
  SmileIframe,
  SmileImage,
  SmileInput,
  SmileLoading,
  SmileLogo,
  SmileMediaCard,
  SmileMessage,
  SmileModal,
  SmileNavbar,
  SmileNotification,
  SmilePagination,
  SmileProgressBar,
  SmileProgressWheel,
  SmileRadio,
  SmileSelect,
  SmileStarRating,
  SmileSteps,
  SmileTabs,
  SmileTag,
  SmileTelInput,
  SmileTimeSlotPicker,
  SmileToast,
  SmileTooltip,
  SmileVideo,
};

// eslint-disable-next-line no-shadow
SdcComponentLibrary.install = function VueUseInstallFunction(Vue) {
  // Install the components
  Object.keys(SdcComponentLibrary).forEach(name => {
    Vue.component(name, SdcComponentLibrary[name]);
  });
};

export default SdcComponentLibrary;

export {
  SmileAppointmentScheduler,
  SmileAudio,
  SmileButton,
  SmileCheckbox,
  SmileCollapse,
  SmileCountrySelector,
  SmileDialog,
  SmileDropdown,
  SmileDropdownItem,
  SmileField,
  SmileFlag,
  SmileHorizontalSlider,
  SmileHero,
  SmileIcon,
  SmileIframe,
  SmileImage,
  SmileInput,
  SmileLoading,
  SmileLogo,
  SmileMediaCard,
  SmileMessage,
  SmileModal,
  SmileNavbar,
  SmileNotification,
  SmilePagination,
  SmileProgressBar,
  SmileProgressWheel,
  SmileRadio,
  SmileSelect,
  SmileStarRating,
  SmileSteps,
  SmileTabs,
  SmileTag,
  SmileTelInput,
  SmileTimeSlotPicker,
  SmileToast,
  SmileTooltip,
  SmileVideo,
};
