# Static Assets

These assets are pulled into the source SCSS from hosted CDN links. Because of this, if you ever need to make an update to these static-assets/ source files, you will need to update the CDN links used in the source code to have the future version number before merging/publishing to ensure library stays in sync with these updates.

Two places you will need to update imports to the future version number:

1. `src/scss/sdc-base.scss`
2. `.storybook/preview-head.html`

Right now, our codepipeline automatically updates the package version to increment the patch number with each PR+publish. This means that if the latest available version is `1.1.2`, you will need to update the CDN import links to have the future `1.1.3` number before merging your PR.

NOTE: This will cause these files to no longer load while observing locally because this version is not actually published yet. As long as you get the next version number correct, they will load as expected when the package publishes. This is an unideal workflow and we are considering how best to change it in the future, sorry for the time being.

If you are unsure about this feel free to reach out to david.jahns@smiledirectclub.com
